#include <M5Atom.h>
#include <WiFi.h>

const char z21Address[] = "192.168.178.200";
const int z21Port = 21105;
const char* SSID = "...";
const char* passwd = "...";

WiFiUDP Udp;
boolean isOn = false;

#define GREEN 0xff0000 // GRB statt RGB
#define RED   0x00ff00
#define WHITE 0xffffff
#define BLACK 0x000000
#define BLUE  0x0000ff

void setup() {
    M5.begin(true, false, true); // Display, SD, Serial
    WiFi.begin(SSID, passwd);
    int i=0; 
    while (WiFi.waitForConnectResult() != WL_CONNECTED) {
      M5.dis.drawpix(i%25,(i/25)%2==0 ? BLUE : BLACK);
      i++;
      delay(100);
    }
    setColor(WHITE);
}

void loop() {
  if (M5.Btn.wasPressed()) {
     isOn = !isOn;
     setColor(isOn ? GREEN : RED);
     setPower(isOn);
  }
  M5.update();
}

void setColor(long color) {
  for (byte i=0; i<25; i++) M5.dis.drawpix(i, color);
}

void setPower(boolean on) {
  uint8_t bytesOn[]  = { 0x07, 0x00, 0x40, 0x00, 0x21, 0x81, 0xa0 };
  uint8_t bytesOff[] = { 0x07, 0x00, 0x40, 0x00, 0x21, 0x80, 0xa1 };

  Udp.beginPacket(z21Address, z21Port);
  Udp.write(on ? bytesOn : bytesOff, 7);
  Udp.endPacket();
}
